#!/usr/bin/wish 
#################################################################################
#													  #
#			   CAIcal PERL version 1.4	  			          	  #
#			         (July 2009)					              #
#													  #
#  This version of CAIcal/E-CAI calculates the Codon Adaptation Index (CAI)     #
#  from DNA sequences or the expected CAI determined by randomly generating     #
#  sequences.											  #
#													  #
#	         Created by Pere Puigbo (puigboap".'@'."ncbi.nlm.nih.gov)		  #
#													  #
#  	 	Freely available at http://genomes.urv.cat/CAIcal.   			  #
#													  #
#		P.Puigb, I.G.Bravo and S.Garcia-Vallv  2007 URV			  #
#													  #
#################################################################################

#################################################################################################################################
# Capalera del programa
frame .title -bd 4 -relief groove 
pack .title -padx 1 -pady 1 -side top

	set img [image create photo -height 60 -width 170 -file img/icone.gif] 
	label .title.lb1 -image $img
	pack .title.lb1 -padx 2m -pady 2m -side left 

	label .title.cap -text "CAIcal/E-CAI version 1.4\n\nP.Puigb, I.G.Bravo and S.Garcia-Vallv  2007 URV\npuigboap@ncbi.nlm.nih.gov\nhttp://genomes.urv.cat/CAIcal"  -height 5 -width 50
	pack  .title.cap  -padx 2m -pady 2m -side top

#################################################################################################################################




#################################################################################################################################
frame .pr -bd 2 -relief groove 
pack .pr -side top -padx 2m -pady 2m
	#################################################################################################################################
	#Frame principal
	frame .pr.princ0 -bd 2 -relief groove 
	pack .pr.princ0 -side left -padx 2m -pady 2m
		#################################################################################################################################
		#Frame principal
		frame .pr.princ0.p -bd 2 -relief groove 
		pack .pr.princ0.p -side top -padx 2m -pady 2m
		
			#######################################################################################################################
			# Nom del fitxer
			label .pr.princ0.p.file -text "INPUT DATA FILE (-f)" -height 1 -width 35
			pack .pr.princ0.p.file -side top -padx 1m -pady 1m
		
			button .pr.princ0.p.control -text Browse -command { set file [tk_getOpenFile]}
			pack .pr.princ0.p.control -padx 1 -pady 1 -side left
		
			entry .pr.princ0.p.e1 -width 35 -textvariable file -bg white
			pack .pr.princ0.p.e1 -padx 1 -pady 1
		
		
		#Frame principal
		frame .pr.princ0.princb -bd 2 -relief groove 
		pack .pr.princ0.princb -side top -padx 2m -pady 2m
		
		
			label .pr.princ0.princb.file2 -text "INPUT HOST FILE (-h)" -height 1 -width 35
			pack .pr.princ0.princb.file2 -side top -padx 2m -pady 2m
		
			button .pr.princ0.princb.control2 -text Browse -command { set host [tk_getOpenFile]}
			pack .pr.princ0.princb.control2 -padx 1 -pady 1 -side left
			
			entry .pr.princ0.princb.e2 -width 35 -textvariable host -bg white
			pack .pr.princ0.princb.e2 -side left
	
	#################################################################################################################################
	
	#Frame principal
	frame .pr.princout -bd 2 -relief groove 
	pack .pr.princout -side top -padx 2m -pady 2m
	
		###############################################################################################################################


		set out1 "./results.txt"
		set out2 "./random_sequences.txt"
		set out3 "./result_expected.txt"


		#Frame out1
		frame .pr.princout.princout1 -bd 2 -relief groove 
		pack .pr.princout.princout1 -side top -padx 2m -pady 2m
		
			# Nom del fitxer
			label .pr.princout.princout1.file -text "OUTPUT 1 (o1 - CAI or RCDI)" -height 1 -width 35
			pack .pr.princout.princout1.file -side top -padx 1m -pady 1m
		
			entry .pr.princout.princout1.e1 -width 35 -textvariable out1 -bg white
			pack .pr.princout.princout1.e1 -padx 1 -pady 1
		
		
		#Frame out2
		frame .pr.princout.princout2 -bd 2 -relief groove 
		pack .pr.princout.princout2 -side top -padx 2m -pady 2m
		
		
			label .pr.princout.princout2.file2 -text "OUTPUT 2 (o2 - Random sequences)" -height 1 -width 35
			pack .pr.princout.princout2.file2 -side top -padx 2m -pady 2m
		
			
			entry .pr.princout.princout2.e2 -width 35 -textvariable out2 -bg white
			pack .pr.princout.princout2.e2 -side left
		
		#Frame out3
		frame .pr.princout.princout3 -bd 2 -relief groove 
		pack .pr.princout.princout3 -side top -padx 2m -pady 2m
		
		
			label .pr.princout.princout3.file2 -text "OUTPUT 3 (o3 - EXPECTED CAI or RCDI)" -height 1 -width 35
			pack .pr.princout.princout3.file2 -side top -padx 2m -pady 2m
			
			entry .pr.princout.princout3.e2 -width 35 -textvariable out3 -bg white
			pack .pr.princout.princout3.e2 -side left
		
		
		###############################################################################################################################
	#################################################################################################################################




#Frame principal
frame .princ -bd 2 -relief groove 
pack .princ -side top -padx 2m -pady 2m

	########################################################################################################################
	# Frame methods
	frame .princ.execution -bd 2 -relief groove 
	pack .princ.execution -side left -padx 2m -pady 2m

		frame .princ.execution.a -bd 2 -relief groove 
		pack .princ.execution.a -side top -padx 2m -pady 2m
			# Labels Methods
			label .princ.execution.a.l1 -text "PROGRAM EXECUTION (-e)" 
			pack .princ.execution.a.l1 -side top -padx 1 -pady 1

			set execution "cai_and_expected"

			
			radiobutton .princ.execution.a.m1 -text "CAI" -variable execution -value "cai"
			radiobutton .princ.execution.a.m2 -text "E-CAI" -variable execution -value "expected"
			radiobutton .princ.execution.a.m3 -text "CAI and E-CAI" -variable execution -value "cai_and_expected"
			radiobutton .princ.execution.a.m4 -text "RCDI" -variable execution -value "rcdi"
			radiobutton .princ.execution.a.m5 -text "E-RCDI" -variable execution -value "ercdi"
			radiobutton .princ.execution.a.m6 -text "RCDI and E-RCDI" -variable execution -value "rcdi_and_ercdi"

			pack .princ.execution.a.m1 .princ.execution.a.m2 .princ.execution.a.m3 .princ.execution.a.m4 .princ.execution.a.m5 .princ.execution.a.m6 -padx 1 -pady 1 -side top -anchor w
		
	
		frame .princ.execution.b -bd 2 -relief groove 
		pack .princ.execution.b -side bottom -padx 2m -pady 2m

			# Labels Methods

			set genetic 1

			label .princ.execution.b.l2 -text "GENETIC CODE (-g)\n1|2|3|4|5|6|9|10|11|12|13|14|15"
			pack .princ.execution.b.l2 -side top 
		
			entry .princ.execution.b.e1 -width 2 -textvariable genetic -bg white
			pack .princ.execution.b.e1 -side top


	########################################################################################################################
	# Frame random
	frame .princ.method -bd 2 -relief groove 
	pack .princ.method -side left -anchor n -padx 2m -pady 2m

		frame .princ.method.a -bd 2 -relief groove 
		pack .princ.method.a -side top -anchor n -padx 2m -pady 2m
		
		# Labels Methods
		label .princ.method.a.l1 -text "E-CAI METHOD (-m)"
		pack .princ.method.a.l1 -side top 
		
	
		set random "markov"	

		radiobutton .princ.method.a.m1 -text Poisson -variable random -value poisson 
		radiobutton .princ.method.a.m2 -text Markov -variable random  -value markov
		pack .princ.method.a.m1 .princ.method.a.m2 -padx 1 -pady 1 -side top -anchor w
	

		frame .princ.method.b -bd 2 -relief groove 
		pack .princ.method.b -side top -anchor n -padx 2m -pady 2m
		
			# Labels Methods
			label .princ.method.b.lc1 -text "CONFIDENCE (-c)"
			pack .princ.method.b.lc1 -side top 
			
			set confidence "95"

			radiobutton .princ.method.b.co1 -text 90% -variable confidence -value 90 
			radiobutton .princ.method.b.co2 -text 95% -variable confidence -value 95
			radiobutton .princ.method.b.co3 -text 99% -variable confidence -value 99
			pack .princ.method.b.co1 .princ.method.b.co2 .princ.method.b.co3 -padx 1 -pady 1 -side left -anchor w

		frame .princ.method.c -bd 2 -relief groove 
		pack .princ.method.c -side bottom -anchor n -padx 2m -pady 2m

			# Labels Methods
			label .princ.method.c.lc2 -text "POPULATION (-p)"
			pack .princ.method.c.lc2 -side top 
		
			set population "99"	

			radiobutton .princ.method.c.po1 -text 90% -variable population -value 90 
			radiobutton .princ.method.c.po2 -text 95% -variable population -value 95
			radiobutton .princ.method.c.po3 -text 99% -variable population -value 99
			pack .princ.method.c.po1 .princ.method.c.po2 .princ.method.c.po3 -padx 1 -pady 1 -side left -anchor w
	

	########################################################################################################################
	# Frame random
	frame .princ.seq -bd 2 -relief groove 
	pack .princ.seq -side top -anchor n -padx 2m -pady 2m
	
	# Labels number random trees
	label .princ.seq.l2 -text "\nNUMBER OF SEQUENCES (-n)"
	pack .princ.seq.l2 -side top 

	set number 1000

	entry .princ.seq.e1 -width 10 -textvariable number -bg white
	pack .princ.seq.e1 -side top

	# Labels number random trees
	label .princ.seq.l3 -text "\nLENGTH OF SEQUENCES (-l)"
	pack .princ.seq.l3 -side top 

	set length 300

	entry .princ.seq.e4 -width 10 -textvariable length -bg white
	pack .princ.seq.e4 -side top


	# Labels number random trees
	label .princ.seq.l4 -text "\n% G+C (-gc)\n(OPTIONAL)"
	pack .princ.seq.l4 -side top 

	entry .princ.seq.e5 -width 5 -textvariable gc -bg white
	pack .princ.seq.e5 -side top



	# Split sequences
	set splitseq "n"

	label .princ.seq.l5 -text "\nSPLIT SEQUENCES (-s)\n(OPTIONAL)"
	pack .princ.seq.l5 -side top 

	radiobutton .princ.seq.e61 -text y -variable splitseq -value y 
	radiobutton .princ.seq.e62 -text n -variable splitseq  -value n
	pack .princ.seq.e61 .princ.seq.e62  -side top

	

###################################
# Executar el programa
frame .exe -bd 2 -relief groove 
pack .exe  -padx 1 -pady 1 -side bottom

button .exe.control -text Exit -command {exit}
pack .exe.control -padx 1 -pady 1 -side left

button .exe.topd -text "Execute CAIcal/E-CAI" -command {
	tk_messageBox -icon info -message "Please be patient, this process may take several minutes.\nClick OK to proceed."
	exec perl ./scr/CAIcal_ECAI_v1.4.pl -f $file -h $host -e $execution -o1 $out1 -o2 $out2 -o3 $out3 -c $confidence -p $population -m $random -n $number -l $length -gc $gc -s $splitseq -g $genetic > out
	tk_messageBox -icon info -message "Done.\nThanks for using CAIcal/E-CAI"
} 
pack .exe.topd -padx 1 -pady 1 -side bottom











